// CreditVerification.cpp 
#include "stdafx.h"

#define _DLL
#include "creditverification_h.h"
#include "creditverification.h"

class CCreditVerification : 
	public ICreditVerification2, public ISomethingElse
{
public:
	HRESULT __stdcall GetCardType(int i, unsigned char* s)
	{
		switch(i)
		{
		case 0: strcpy((char*)s, "Visa");
			return S_OK;
		case 1: strcpy((char*)s, "MasterCard");
			return S_OK;
		case 2: strcpy((char*)s, "Amex");
			return S_OK;
		default: strcpy((char*)s, "Unrecognised");
			return E_INVALIDARG;
		}
	}

	HRESULT __stdcall SetCardType(unsigned char* s)
	{
		if (0 == strcmp("Visa", (const char*)s))
			m_type = Visa;
		else if (0 == strcmp("MasterCard", (const char*)s))
			m_type = MasterCard;
		else m_type = Amex;
		return S_OK;
	}
	HRESULT __stdcall VerifyCardNumber(long n) 
	{
		if (m_type == Visa && (n % 2))
			return S_OK;
		else if (m_type == MasterCard && (n % 3))
			return S_OK;
		else if (m_type == Amex && (n % 5))
			return S_OK;
		else return E_INVALIDARG;
	}

	HRESULT __stdcall Foo() { return S_OK; }

	HRESULT __stdcall QueryInterface(REFIID iid, void**pp)
	{
		if (NULL == pp)
			return E_INVALIDARG;
		*pp = NULL;

		if (iid == IID_IUnknown) 
			*pp = this;
		else if (iid == IID_ICreditVerification)
			*pp = static_cast<ICreditVerification*>(this);
		else if (iid == IID_ISomethingElse)
			*pp = static_cast<ISomethingElse*>(this);
		else if (iid == IID_ICreditVerification2)
			*pp = static_cast<ICreditVerification2*>(this);

		if (*pp)
		{
			AddRef();
			return S_OK;
		}
		return E_NOINTERFACE;

		return 0; 
	}

	ULONG __stdcall AddRef() { return ++m_refCount; }
	ULONG __stdcall Release() 
	{
		if (--m_refCount == 0) 
		{
			delete this;
			return 0;
		}
		return m_refCount;
	}
	CCreditVerification() : m_refCount(0) {}

private:
	enum CardType {Visa, MasterCard, Amex} m_type;
	long m_refCount;
};

DLLSPEC ICreditVerification* GetCreditVerificationObject()
{
	ICreditVerification* p = new CCreditVerification;
	p->AddRef();
	return p;
}

BOOL APIENTRY DllMain(HANDLE hModule,
	DWORD  ul_reason_for_call, LPVOID lpReserved)
{
    return TRUE;
}
