// TestCCV.cpp 
#include "stdafx.h"
#include "..\CreditVerification\CreditVerification_h.h"
#include "..\CreditVerification\CreditVerification.h"

int _tmain(int argc, _TCHAR* argv[])
{
	ICreditVerification* c = GetCreditVerificationObject();
	c->SetCardType((unsigned char*)"MasterCard");
	if (c->VerifyCardNumber(1234) == S_OK)
		MessageBox(0, "Card Verified", "OK", 0);
	else
		MessageBox(0, "Card Rejected", 0, 0);

	ISomethingElse* s;
	HRESULT hr = c->QueryInterface(IID_ISomethingElse, (void**)&s);
	if (FAILED(hr))
	{
		MessageBox(0, "QI failed on ISomethingElse", 0, 0);
		c->Release();
		return 1;
	}
	s->Foo();

	ICreditVerification2* v;
	hr = s->QueryInterface(IID_ICreditVerification2, (void**)&v);
	if (FAILED(hr))
	{
		MessageBox(0, "QI failed on ICreditVerification2", 0, 0);
		s->Release();
		c->Release();
		return 1;
	}
	char buf[32] = {0};
	
	hr = v->GetCardType(2, (unsigned char*)buf);
	if (SUCCEEDED(hr))
		MessageBox(0, buf, "Card Type", 0);

	v->Release();
	s->Release();
	c->Release();
	return 0;
}

